/********************************************************************/
/*                                                                  */
/*  s7   Seed7 interpreter                                          */
/*  Copyright (C) 1990 - 2000  Thomas Mertes                        */
/*                                                                  */
/*  This program is free software; you can redistribute it and/or   */
/*  modify it under the terms of the GNU General Public License as  */
/*  published by the Free Software Foundation; either version 2 of  */
/*  the License, or (at your option) any later version.             */
/*                                                                  */
/*  This program is distributed in the hope that it will be useful, */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of  */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   */
/*  GNU General Public License for more details.                    */
/*                                                                  */
/*  You should have received a copy of the GNU General Public       */
/*  License along with this program; if not, write to the           */
/*  Free Software Foundation, Inc., 51 Franklin Street,             */
/*  Fifth Floor, Boston, MA  02110-1301, USA.                       */
/*                                                                  */
/*  Module: Main                                                    */
/*  File: seed7/src/option.h                                        */
/*  Changes: 1994  Thomas Mertes                                    */
/*  Content: Reads and interprets the command line options.         */
/*                                                                  */
/********************************************************************/

#define TRACE_ACTIONS            1
#define TRACE_DO_ACTION_CHECK    2
#define TRACE_DYNAMIC_CALLS      4
#define TRACE_EXCEPTIONS         8
#define TRACE_HEAP_SIZE         16
#define TRACE_MATCH             32
#define TRACE_EXECUTIL          64
#define WRITE_LIBRARY_NAMES    128
#define WRITE_LINE_NUMBERS     256
#define SHOW_IDENT_TABLE       512
#define SHOW_STATISTICS       1024

typedef struct {
    stritype          source_file_argument;
    const_stritype    prot_file_name;
    booltype          write_help;
    booltype          analyze_only;
    booltype          execute_always;
    uinttype          parser_options;
    uinttype          exec_options;
    booltype          catch_signals;
    rtlArraytype      seed7_libraries;
    rtlArraytype      argv;
    memsizetype       argv_start;
  } opttype;

#ifdef DO_INIT
opttype option = {
    NULL,  /* source_file_name  */
    NULL,  /* prot_file_name    */
    FALSE, /* write_help        */
    FALSE, /* analyze_only      */
    FALSE, /* execute_always    */
    0,     /* parser_options    */
    0,     /* exec_options      */
    TRUE,  /* catch_signals     */
    NULL,  /* seed7_libraries   */
    NULL,  /* argv              */
    0,     /* argv_start        */
  };
#else
EXTERN opttype option;
#endif
